<?php
/**
 * Zend Framework (http://framework.zend.com/)
 *
 * @link      http://github.com/zendframework/ZendSkeletonApplication for the canonical source repository
 * @copyright Copyright (c) 2005-2014 Zend Technologies USA Inc. (http://www.zend.com)
 * @license   http://framework.zend.com/license/new-bsd New BSD License
 */

namespace Admin\Controller;

use Zend\Mvc\Controller\AbstractActionController;
use Zend\View\Model\ViewModel;
use Zend\Session\Container;
use Admin\Controller\DatabaseConfig;

class PromotionController extends AbstractActionController{
	
	public $con = '';
	private $data = array();
	
	public function __construct(){
            $db = new DatabaseConfig();
            $this->con = $db->getDatabaseConfig();
	}
	
	public function indexAction(){
		$c=1;
		$sql = "SELECT * FROM promotion";
		$qry = mysqli_query($this->con,$sql);
		while($row = mysqli_fetch_assoc($qry)){
			$days = '';
			if($row['week_days']){
				$days = '<ul>';
				foreach(explode(',',$row['week_days']) as $val){
					$days .= "<li>$val</li>";
				}
				$days .= "</ul>";
			}
			$this->data [] = array(
									$c++, 
                                                                        '<img src="'.$row['promotion_image'].'" width="100" height="100">',
									$row['PromotionName'], 
									date('d M Y',strtotime($row['valid_date_from'])), 
									date('d M Y',strtotime($row['valid_date_to'])), 
									date('h:i a',strtotime($row['valid_time_from'])), 
									date('h:i a',strtotime($row['valid_time_to'])), 
									$days, 
									$row['minimum_booking_amount'], 
									$row['discount'], 
									'<a href="promotion/edit?id='.$row['id'].'">Edit</a> | <a href="promotion/delete?id='.$row['id'].'" onclick="return confirm('."'Are you sure want to delete this record'".');" >Delete</a>');
		}
		$this->data = json_encode(array('data'=>$this->data));
		return new viewModel(array('data'=>$this->data));
	}
	
	public function addAction(){
		$BookingTypeList = "<option value=''>Select Booking Type</option>";
		$TimeList = "<option value=''>Select Time</option>";
		for($a=0;$a<=23;$a++){
			for($b=0;$b<2;$b++){
				if($b%2==1){
					$min = 30;
				}else{
					$min = 0;
				}
				$time = mktime($a,$min,0,0,0,0);
				$TimeList .= "<option value='".date('h:i A',$time)."'>".date('h:i A',$time)."</option>";
			}
		}
		$sql = "SELECT Package_Id, Master_Package FROM master_package";
		$qry = mysqli_query($this->con, $sql) or die(mysqli_error());
		while($row = mysqli_fetch_object($qry)){
			$BookingTypeList .= "<option value='".$row->Package_Id."'>".$row->Master_Package."</option>";
		}
		$this->data = array(
			'TimeList'=>$TimeList,
			'BookingTypeList'=>$BookingTypeList
		);
		return new viewModel(array('data'=>$this->data));
	}
	
	public function saveAction(){
		$fields = '';
		$values = '';
                
                $name = $_FILES['PromotionImage']['name'];
                $tmpName = $_FILES['PromotionImage']['tmp_name'];
                $name = time() . $name;
                $targetPath = PUBLIC_PATH . "/images/promotion/" . $name;
                $uploaded = move_uploaded_file($tmpName, $targetPath);
                
		$data = array(
			'PromotionName'=>$_POST['PromotionName'],
			'PromotionDescription'=>$_POST['PromotionDescription'],
			'CouponType'=>$_POST['CouponType'],
			'ValidDateFrom'=>date('Y-m-d',strtotime($_POST['ValidDateFrom'])),
			'ValidDateTo'=>date('Y-m-d',strtotime($_POST['ValidDateTo'])),
			'ValidTimeFrom'=>date('H:i',strtotime($_POST['ValidTimeFrom'])),
			'ValidTimeTo'=>date('H:i',strtotime($_POST['ValidTimeTo'])),
			'WeekDays'=>implode(',', $_POST['WeekDays']),
			'BookingTypeId'=>$_POST['BookingTypeId'],
			'MinimumBookingAmount'=>$_POST['MinimumBookingAmount'],
			'DiscountType'=>$_POST['DiscountType'],
                        'TermsCondition'=>$_POST['TermsCondition'],
			'Discount'=>$_POST['Discount'],
                        'PromotionImage'=>'/images/promotion/'.$name,
		);
		foreach($data as $key=>$val){
			$fields .= "`$key`,";
			$values .= "'$val',";
		}
		$fields = substr($fields,0,-1);
		$values = substr($values,0,-1);
		$sql = "INSERT INTO tblpromotion ($fields) VALUES ($values)";
		$qry = mysqli_query($this->con,$sql);
		header('location: /admin/promotion');
		exit();
	}
	
	public function editAction(){
				
		$sql = "SELECT * FROM promotion WHERE id = '".$_REQUEST['id']."'";
		$qry = mysqli_query($this->con, $sql);
		$Rec = mysqli_fetch_object($qry);
		
		$BookingTypeList = "<option value=''>Select Booking Type</option>";
		$TimeList = "<option value=''>Select Time</option>";
		for($a=0;$a<=23;$a++){
			for($b=0;$b<2;$b++){
				if($b%2==1){
					$min = 30;
				}else{
					$min = 0;
				}
				$time = mktime($a,$min,0,0,0,0);
				$TimeList .= "<option selected='selected' value='".date('h:i A',$time)."'>".date('h:i A',$time)."</option>";
			}
		}
		$sql = "SELECT package_id, master_package FROM master_package";
		$qry = mysqli_query($this->con, $sql) or die(mysqli_error());
		while($row = mysqli_fetch_object($qry)){
			$BookingTypeList .= "<option value='".$row->package_id."'>".$row->master_package."</option>";
		}
		$this->data = array(
			'TimeList'=>$TimeList,
			'BookingTypeList'=>$BookingTypeList,
			'Rec'=>$Rec
		);
				
		return new viewModel(array('data'=>$this->data));
	}
	
	public function updateAction(){
		$recs = '';
                
                
                $image = $_FILES['PromotionImage']['name'];
                $promotion_image_hidden=$_POST['promotion_image_hidden'];
                if($image!=""){
                    //echo "Mohit"; die;
                    unlink(BASE_PATH.'/'.$promotion_image_hidden);
                    $name = $_FILES['PromotionImage']['name'];
                    $tmpName = $_FILES['PromotionImage']['tmp_name'];
                    $name = time() . $name;
                    $targetPath = PUBLIC_PATH . "/images/promotion/" . $name;
                    $uploaded = move_uploaded_file($tmpName, $targetPath);
                    $image_name=  '/images/promotion/'.$name;                    
                }else{
                     $image_name=  $promotion_image_hidden;                    
                }
                
                
		$data = array(
			'promotion_name'=>$_POST['PromotionName'],
			'promotion_description'=>$_POST['PromotionDescription'],
			'coupon_type'=>$_POST['CouponType'],
			'valid_date_from'=>date('Y-m-d',strtotime($_POST['ValidDateFrom'])),
			'valid_date_to'=>date('Y-m-d',strtotime($_POST['ValidDateTo'])),
			'valid_time_from'=>date('H:i',strtotime($_POST['ValidTimeFrom'])),
			'valid_time_to'=>date('H:i',strtotime($_POST['ValidTimeTo'])),
			'week_days'=>implode(',', $_POST['WeekDays']),
			'booking_type_id'=>$_POST['BookingTypeId'],
			'minimum_booking_amount'=>$_POST['MinimumBookingAmount'],
			'discount_type'=>$_POST['DiscountType'],
                        'terms_condition'=>$_POST['TermsCondition'],
			'discount'=>$_POST['Discount'],
                        'promotion_image'=>$image_name,
		);
		foreach($data as $key=>$val){
			$recs .= "`$key`='$val',";
		}
		$recs = substr($recs,0,-1);
		$sql = "UPDATE promotion SET $recs WHERE id = '".$_REQUEST['id']."'";
		$qry = mysqli_query($this->con,$sql);
		header('location: /admin/promotion');
		exit();
	}
	
	public function deleteAction(){
		$sql = "DELETE FROM promotion WHERE id = '".$_REQUEST['id']."'";
		$qry = mysqli_query($this->con, $sql);
		header('location: /admin/promotion');
		exit();
	}
}
