// This example creates an interactive map which constructs a
// polyline based on user clicks. Note that the polyline only appears
// once its path property contains two LatLng coordinates.

var poly;
var map;
var src;
var src2;
var booking_id;


var service = new google.maps.DirectionsService();


function initialize() {

    var marker = new Array;

    var mapOptions = {zoom: 10, center: new google.maps.LatLng(28.6519649, 77.1943095)};

    map = new google.maps.Map(document.getElementById('map-canvas'), mapOptions);


    var polyOptions = {strokeColor: '#000000', strokeOpacity: 1.0, strokeWeight: 3};
    var polyOptions2 = {strokeColor: '#0000ff', strokeOpacity: 1.0, strokeWeight: 3};
    var polyOptions3 = {strokeColor: '#ff0000', strokeOpacity: 1.0, strokeWeight: 2};

    poly = new google.maps.Polyline(polyOptions);
    poly2 = new google.maps.Polyline(polyOptions2);
    poly3 = new google.maps.Polyline(polyOptions3);

    poly.setMap(map);
    poly2.setMap(map);
    poly3.setMap(map);

    var path2 = poly2.getPath();
    var path3 = poly3.getPath();
    $.ajax({
        url: '/tunnel/admin/track_lat?data=' + booking_id,
        cache: false,
        dataType: "json"

    }).done(function (html) {

        if (booking_id) {

            console.log(html);

            map.setCenter(new google.maps.LatLng(html.data.lat, html.data.lon));
            var infowindow = new google.maps.InfoWindow();


            var PickupLocationMarker = new google.maps.Marker({
                position: new google.maps.LatLng(html.data.lat, html.data.lon),
                icon: '/images/PingClient.jpg',
                map: map
            });
            var mark = PickupLocationMarker;
            var content = '<table width="100%" border="0"><tr><td colspan="2"><strong>Client Detail</strong></td></tr><tr><td>Name : </td><td>' + html.data.ClientName + '</td></tr><tr><td>Mobile : </td><td>' + html.data.ClientMobileNumber + '</td></tr><tr><td>Cab Reg. No. : </td><td>' + html.data.CabRegistrationNumber + '</td></tr><tr><td>Cab Status : </td><td>' + html.data.cabstatus + '</td></tr><tr><td>Location : </td><td>' + html.data.p + '</td></tr></table>';
            google.maps.event.addListener(mark, 'mouseover', (function (mark, content, infowindow) {
                return function () {
                    infowindow.setContent(content);
                    infowindow.open(map, mark);
                };
            })(mark, content, infowindow));
            google.maps.event.addListener(mark, 'mouseout', (function (mark, content, infowindow) {
                return function () {
                    infowindow.setContent(content);
                    infowindow.close(map, mark);
                };
            })(mark, content, infowindow));

            if (html.data.pickup) {

                var DriverLocationMarker = new google.maps.Marker({
                    position: new google.maps.LatLng(html.data.DriverLat, html.data.DriverLon),
                    icon: '/images/PingDriver.jpg',
                    map: map
                });
                var mark = DriverLocationMarker;
                var content = '<table width="100%" border="0"><tr><td colspan="2"><strong>Driver Detail</strong></td></tr><tr><td>Driver Name : </td><td>' + html.data.DriverName + '</td></tr><tr><td>Mobile : </td><td>' + html.data.DriverMobileNumber + '</td></tr><tr><td>Cab Reg. No. : </td><td>' + html.data.CabRegistrationNumber + '</td></tr><tr><td>Cab Status : </td><td>' + html.data.cabstatus + '</td></tr><tr><td>Location : </td><td>' + html.data.d + '</td></tr></table>';
                google.maps.event.addListener(mark, 'mouseover', (function (mark, content, infowindow) {
                    return function () {
                        infowindow.setContent(content);
                        infowindow.open(map, mark);
                    };
                })(mark, content, infowindow));
                google.maps.event.addListener(mark, 'mouseout', (function (mark, content, infowindow) {
                    return function () {
                        infowindow.setContent(content);
                        infowindow.close(map, mark);
                    };
                })(mark, content, infowindow));

                service.route({
                    origin: new google.maps.LatLng(html.data.lat, html.data.lon),
                    destination: new google.maps.LatLng(html.data.DriverLat, html.data.DriverLon),
                    travelMode: google.maps.TravelMode['DRIVING']
                }, function (result, status) {
                    if (status == google.maps.DirectionsStatus.OK) {
                        for (var i = 0, len = result.routes[0].overview_path.length; i < len; i++) {
                            path2.push(result.routes[0].overview_path[i]);
                        }
                    }
                });
            }

            $.each(html.data.Waiting, function (i, obj) {

                latlng = new google.maps.LatLng(obj.WaitLat, obj.WaitLon);

                marker[obj.id] = new google.maps.Marker({
                    position: latlng,
                    //icon:'<?php echo $this->basePath(); ?>/public/images/PingDriver.jpg',
                    map: map,
                    customInfo: obj.id
                });

                var mark = marker[obj.id];
                var content = '<table width="100%" border="0"><tr><td colspan="2"><strong>Waiting Detail</strong></td></tr><tr><td>Time : </td><td>' + obj.datetime + '</td></tr><tr><td>Waiting Time : </td><td>' + obj.WaitingTime + '</td></tr></table>';

                google.maps.event.addListener(mark, 'mouseover', (function (mark, content, infowindow) {
                    return function () {
                        infowindow.setContent(content);
                        infowindow.open(map, mark);
                    };
                })(mark, content, infowindow));

            });



            //addLatLng2();
        }
    });
    // Add a listener for the click event
    //google.maps.event.addListener(map, 'click', addLatLng);

}

/**
 * Handles click events on a map, and adds a new point to the Polyline.
 * @param {google.maps.MouseEvent} event
 */

function addLatLng2() {
    var a;
    var b;
    var latlng;
    var path = poly.getPath();
}

function addLatLng() {
    var a;
    var b;
    var latlng;
    var path = poly.getPath();
    $.ajax({
        url: '/tunnel/admin/track_lat?data=' + booking_id,
        cache: false,
        dataType: "json"
    }).done(function (html) {
        console.log(html);
        a = html.data.Latitude;
        b = html.data.Longtitude1;
        latlng = new google.maps.LatLng(a, b);
        service.route({
            origin: src,
            destination: latlng,
            travelMode: google.maps.TravelMode['DRIVING']
        }, function (result, status) {
            if (status == google.maps.DirectionsStatus.OK) {
                for (var i = 0, len = result.routes[0].overview_path.length; i < len; i++) {
                    path.push(result.routes[0].overview_path[i]);
                }
            }
        });
    });
    src = new google.maps.LatLng(a, b);
    // Because path is an MVCArray, we can simply append a new coordinate
    // and it will automatically appear.
    // path.push(event.latLng);
    // Add a new marker at the new plotted point on the polyline.
}

google.maps.event.addDomListener(window, 'load', initialize);
//setInterval(function(){addLatLng()},30000);
