var poly;
var map;
var driver_id;
var lat = getUrlVars()["lat"];
var lon = getUrlVars()["lon"];
var latnt;
var marker = new Array;
var html_new = new Array;

$(document).ready(function () {
    $('#search_button').click(function () {
        var SearchKey = $('#search').val();
        getLocation('', SearchKey)
    });
});


/**
 * Handles click events on a map, and adds a new point to the Polyline.
 * @param {google.maps.MouseEvent} event
 */


function SetBooking(Range) {
    $('#ref').show();
    $('#ref').html('');
    $.ajax({
        type: 'POST',
        url: "/tunnel/admin/getUnassignedBooking",
        dataType: "json",
        data: {DriverId: driver_id, BookingRange: Range},
        success: function (data) {
            $('#ref').append($("<option value='0'>Select Booking Refrence</option>"));

            $.each(data.data, function (i) {
                $.each(data.data[i], function (key, obj) {
                    $('#ref').append($("<option value='" + obj.BookingId + "'>" + obj.booking_reference + "</option>"));
                });
            });
        },
        error: function () {
            console.log(error);
        }

    });
}


function getUrlVars() {
    var vars = {};
    var parts = window.location.href.replace(/[?&]+([^=&]+)=([^&]*)/gi, function (m, key, value) {
        vars[key] = value;
    });
    return vars;
}

google.maps.event.addDomListener(window, 'load', function () {
    getLocation('All');
});//initialize


function getLocation(Status, Search) {

    var CabImage = '/image/car_1.png';
    var mapOptions = {
        zoom: 10,
        center: new google.maps.LatLng(28.6100, 77.2300),
    };

    if (navigator.geolocation) {
        browserSupportFlag = true;

        navigator.geolocation.getCurrentPosition(function (position) {
            initialLocation = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);

            map.setCenter(initialLocation);

        });
    } else {

        alert("Your browser doesn't support geolocation.");

    }


    map = new google.maps.Map(document.getElementById('map-canvas'), mapOptions);

    var polyOptions = {
        strokeColor: '#000000',
        strokeOpacity: 1.0,
        strokeWeight: 3
    };

    $.ajax({
        type: 'POST',
        url: "/tunnel/admin/getCabInfo",
        data: {CabStatus: Status, SearchKey: Search},
        cache: false,
        dataType: "json",
        success: function (html) {

            for (i = 0; i < html.data.length; i++) {

                if (html.data[i].CabStatus == 'Free') {
                    CabImage = '/images/1.png';
                } else if (html.data[i].CabStatus == 'Logout') {
                    CabImage = '/images/5.png';
                } else if (html.data[i].CabStatus == 'Reported') {
                    CabImage = '/images/8.png';
                } else if (html.data[i].CabStatus == 'Located') {
                    CabImage = '/images/Located.jpg';
                } else if (html.data[i].CabStatus == 'Accepted') {
                    CabImage = '/images/4.png';
                } else if (html.data[i].CabStatus == 'OnCall') {
                    CabImage = '/images/3.png';
                } else if (html.data[i].CabStatus == 'Hired') {
                    CabImage = '/images/2.png';
                }


                latlng = new google.maps.LatLng(html.data[i].Latitude, html.data[i].Longtitude1);

                marker[html.data[i].id] = new google.maps.Marker({
                    position: latlng,
                    icon: CabImage,
                    title: html.data[i].LoginName,
                    map: map,
                    customInfo: html.data[i].id
                });

                var infowindow = new google.maps.InfoWindow();

                var mark = marker[html.data[i].id];
                var content = '<table style="font-size:11px;"><tr><td><strong>Driver Name :</strong> </td><td>' + html.data[i].DriverName + '</td></tr><tr><td> <strong>Mobile Number :</strong> </td><td>' + html.data[i].MobileNumber + '</td></tr><tr><td><strong>Cab Type :</strong></td><td>' + html.data[i].CabType + '</td></tr><tr><td><strong>Cab Registration No. :</strong></td><td>' + html.data[i].CabRegistrationNumber + '</td></tr><tr><td><strong>Cab Status :</strong></td><td>' + html.data[i].CabStatus + '<span><img src="' + CabImage + '"></span></td></tr><tr><td><strong>Cab Location :</strong></td><td width="100">' + html.data[i].Location + '</td></tr></table>';


                google.maps.event.addListener(mark, 'mouseover', (function (mark, content, infowindow) {
                    return function () {
                        infowindow.setContent(content);
                        infowindow.open(map, mark);
                    };
                })(mark, content, infowindow));

                google.maps.event.addListener(mark, 'mouseout', (function (mark, content, infowindow) {
                    return function () {
                        infowindow.setContent(content);
                        infowindow.close(map, mark);
                    };
                })(mark, content, infowindow));

                if (html.data[i].driverStatus == 0 && html.data[i].login_status == 1) {
                    google.maps.event.addListener(marker[html.data[i].id], 'dblclick', function () {
                        driver_id = this.customInfo;
                        document.getElementById("myText").value = driver_id;
                        //SetBooking();
                        $("#cabTypeForm").bPopup();
                    });
                }

                google.maps.event.addListener(marker[html.data[i].id], 'click', function () {
                    var mark = marker[html.data[i].id];
                    map.setCenter(mark.getPosition());
                });

            }
        },
        error: function (error) {
            console.log(error);
        }
    });

    poly = new google.maps.Polyline(polyOptions);
    poly.setMap(map);
    // Add a listener for the click event
}